package org.processmining.plugins.timefilter.ui;

import java.awt.Color;
import java.util.HashMap;

/**
 * This class contains the basic colors of the plugins
 * 
 * @author Andrea Burattin
 */
public class UIColors {

	// basic ui colors
	public static final Color darkGray = new Color(28, 28, 28);
	public static final Color gray = new Color(82, 82, 82);
	public static final Color lightGray = new Color(119, 119, 119);
	public static final Color lightLightGray = new Color(194, 194, 194);
	
	// line chart widget colors
	public static final Color lineChartBackground = new Color(10, 10, 10);
	public static final Color lineChartVerticalBars = Color.DARK_GRAY;
	public static final Color lineChartDividerBackground = new Color(0, 0, 0, 200);
	public static final Color lineChartDividerLine = Color.GRAY;
	public static final Color lineChartTextcolor = new Color(255, 255, 255, 200);
	public static final Color lineChartLegend = new Color(255, 255, 255, 100);
	public static final Color lineChartBarColorUniform = new Color(175, 0, 0, 255);
	// cache of colors
	private static HashMap<Double, Color> colorCache = new HashMap<Double, Color>();
	
	/**
	 * 
	 * @param value
	 * @return
	 */
	public static Color fromValueToColor(double value) {
		if (value > 1) value = 1;
		if (value < 0) value = 0;
		
		int brightestRedComponent = 255;
		int darkestRedComponent = 100;
		int valueRedComponent = darkestRedComponent + (int)((brightestRedComponent - darkestRedComponent) * value);
		
		if (colorCache.containsKey(valueRedComponent)) {
			return colorCache.get(valueRedComponent);
		}
		Color c = new Color(valueRedComponent, 0, 0, 255);
		colorCache.put(value, c);
		return c;
	}
}
